/*
 *  ===============================================================================
 *  TestRelationship.java: Systematically assemble a one-to-many relationship graph
 *                         between an academic department and students.
 *  ===============================================================================
 */

package association03;

import java.util.Map;
import java.util.HashMap;
import java.util.TreeMap;

public class TestRelationship {
  public static void main( String[] args ) {

    // Create student objects ...

    Student student01 = new Student();
    student01.setName("Joe");
    student01.setId( 001 );
    Student student02 = new Student();
    student02.setName("Jill");
    student02.setId( 002 );
    Student student03 = new Student();
    student03.setName("Naomi");
    student03.setId( 003 );
    Student student04 = new Student();
    student04.setName("Alexi");
    student04.setId( 004 );
    Student student05 = new Student();
    student05.setName("Zack");
    student05.setId( 005 );

    // Print details of individual students (not yet enrolled in a department) ...

    System.out.println("List of students (not yet enrolled)");
    System.out.println("===================================");

    System.out.println ( student01 );
    System.out.println ( student02 );
    System.out.println ( student03 );
    System.out.println ( student04 );
    System.out.println ( student05 );

    // Create department object ...
    
    Department dept = new Department();
    dept.setName( "CEE" );
    dept.setId( 004 );

    // Add students to department ...

    dept.addStudent( student01 );
    dept.addStudent( student02 );
    dept.addStudent( student03 );
    dept.addStudent( student04 );
    dept.addStudent( student05 );

    System.out.println("List of students enrolled in CEE   ");
    System.out.println("===================================");

    Map students = dept.getStudents();
    System.out.println ( students );

    // Organize students into a tree map ...

    System.out.println("Ordered list of students enrolled in CEE   ");
    System.out.println("===========================================");

    Map organizedStudents = new TreeMap( students );
    System.out.println ( organizedStudents );
  }
}
