/**
 *  =========================================================================
 *  PassengerDataItem.java: Use hashmap to store details of passenger record.
 *  
 *  Note: To keep things simple, both the keys and their values are
 *        modeled as strings.  
 *  
 *  Written by: Mark Austin                                        April 2022  
 *  =========================================================================
 */

package homework03;

import java.util.LinkedHashMap;
import java.util.*;

public class PassengerDataItem {
   LinkedHashMap<String,String> data;

   public PassengerDataItem() {
      data = new LinkedHashMap<String,String> ();
   }

   // ====================================================
   // Add entry to data item ...
   // ====================================================

   public void add ( String name, String value ) {
      data.put (name, value);
   }

   // ====================================================
   // Retrieve specific items ...
   // ====================================================

   public String get ( String name ) {
      return data.get( name );
   }

   // ====================================================
   // Create string representation of passenger record ...
   // ====================================================

   public String toString() {
      StringBuffer buf = new StringBuffer();

      for (String key : data.keySet()) {
          buf.append( String.format("--- %s, %s ... \n", key, data.get(key) ));
      }

      return buf.toString();
   }
}
