/*
 *  =====================================================================
 *  TestFunction.java: Exercise function interface and builtin functions.
 *
 *  Written by: Mark Austin                                    June, 2013
 *  =====================================================================
 */

package interface01;

import java.util.HashMap;

public class TestFunction {
   public static void main ( String args[] ) {

      // Create references to builtin functions ..

      Function m = new Max();
      Function n = new Min();

      // Create simple hashmap of references to builtin functions ...

      HashMap<String,Function> builtins = new HashMap<String,Function>();
      builtins.put( m.getName(), m );
      builtins.put( n.getName(), n );

      // Retrieve and compute values ...

      System.out.println("");
      System.out.println("Part 01: Compute Max(1,5) ....");

      Function k    = (Function) builtins.get ( "Max" );
      k.setValues ( 1.0, 5.0 );
      double result = k.compute();
      System.out.println("*** Function name = " + k.getName() );
      System.out.println("*** No args    = " + k.getNoArgs() );
      System.out.println("*** Max result = " + result );

      System.out.println("");
      System.out.println("Part 02: Compute Max(1,2,3) ....");

      Function p = (Function) builtins.get ( "Max" );
      p.setValues ( 1.0,  2.0, 3.0 );
      result = p.compute();
      System.out.println("*** Function name = " + p.getName() );
      System.out.println("*** No args    = " + p.getNoArgs() );
      System.out.println("*** Max result = " + result );

      System.out.println("");
      System.out.println("Part 03: Compute Min(1,2,3) ....");

      k = (Function) builtins.get ( "Min" );
      k.setValues ( 1.0,  2.0, 3.0 );
      result = k.compute();
      System.out.println("*** Function name = " + k.getName() );
      System.out.println("*** No args    = " + k.getNoArgs() );
      System.out.println("*** Min result = " + result );
   }
}
