/*
 *  ================================================================
 *  Min.java: Specification for builtin function min (x,y)....
 *
 *  Written by: Mark Austin                               June, 2013
 *  ================================================================
 */

package symbol02.datatypes;

import java.lang.Math;

public class Min implements Function {
   double a, b, c, d;
   int noArgs = 0;

   public Min () {}

   public int getNoArgs() {
      return noArgs;
   }

   public void setValues ( double ... numbers ) {
      noArgs = numbers.length;
      switch ( noArgs ) {
         case 2:
              a = numbers[0];
              b = numbers[1];
              break;
         case 3:
              a = numbers[0];
              b = numbers[1];
              c = numbers[2];
              break;
         case 4:
              a = numbers[0];
              b = numbers[1];
              c = numbers[2];
              d = numbers[3];
              break;
         default:
              break;
      }
   }

   public String getName() {
      return "Min";
   }

   public double compute() {
      double result = 0.0;

      switch ( noArgs ) {
         case 2:
              System.out.printf("*** Compute Min.compute(%f, %f) ... \n", a, b);
              result = Math.min ( a, b );
              break;
         case 3:
              System.out.printf("*** Compute Min.compute(%f, %f, %f) ... \n", a, b, c);
              result = Math.min ( Math.min ( a, b ), c );
              break;
         case 4:
              System.out.printf("*** Compute Min.compute(%f, %f, %f %f) ... \n", a, b, c, d);
              result = Math.min ( Math.min ( a, b ), Math.min ( c, d) );
              break;
         default:
              result = 0.0;
              break;
      }

      return result;
   }

   // String representation of Min() function ...

   public String toString() {
      StringBuffer buf = new StringBuffer();
      buf.append( String.format("Min() function : noArgs = %2d\n", noArgs ) );
      switch ( noArgs ) {
         case 2:
              buf.append( String.format("Compute Min.compute(%f, %f) ... \n", a, b ));
              break;
         case 3:
              buf.append( String.format("Compute Min.compute(%f, %f, %f) ... \n", a, b, c) );
              break;
         case 4:
              buf.append( String.format("Compute Min.compute(%f, %f, %f %f) ... \n", a, b, c, d) );
              break;
         default:
      }

      return buf.toString();
   }
}

