/*
 *  ===========================================================================
 *  TestSortTreeMap.java: TreeMap sort demo ....
 *  ===========================================================================
 */

package treemap01;

import java.util.*;

public class TestSortTreeMap {

  // Method for sorting the TreeMap based on values

  public static <K, V extends Comparable<V>> Map<K, V> sortByValues(final Map<K, V> map) {

      // String comparator ...

      Comparator<K> valueComparator = new Comparator<K>() {
         public int compare(K k1, K k2) {
            int compare = map.get(k1).compareTo(map.get(k2));
            if (compare == 0) 
               return 1;
            else 
               return compare;
         }
      };
 
      Map<K, V> sortedByValues = new TreeMap<K, V>(valueComparator);
      sortedByValues.putAll(map);
      return sortedByValues;
  }

  // Test program to sort TreeMap by values ...

  public static void main(String args[]) {

     System.out.printf("Enter TreeSortTreeMap.main()          ...\n");
     System.out.printf("===================================== ...\n");
     System.out.printf("--- Assemble treemap ...\n");

     TreeMap<String, String> treemap = new TreeMap<String, String>();

     // Put elements to the map

     treemap.put("Key1", "Parastoo");
     treemap.put("Key2", "Joel");
     treemap.put("Key3", "Chula");
     treemap.put("Key4", "Peng");
     treemap.put("Key5", "Mark");
     treemap.put("Key6", "Maria");
     treemap.put("Key7", "Leonard");
 
     // Call the method sortByvalues

     System.out.printf("--- Sort entries by value ...\n");

     Map sortedMap = sortByValues(treemap);
 
     // Get a set of the entries on the sorted map

     System.out.printf("--- Retrieve set of sorted values ...\n");

     Set set = sortedMap.entrySet();
 
     // Display elements

     System.out.printf("--- Traverse set, print (key, value) pairs ...\n");
 
     Iterator i = set.iterator();
     while(i.hasNext()) {
        Map.Entry me = (Map.Entry)i.next();
        System.out.printf("--- (key,value) --> (%5s, %s)...\n", me.getKey(), me.getValue() );
     }

     System.out.printf("===================================== ...\n");
     System.out.printf("Finished !! ...\n");
  }
}
